package mezz.jei.fabric.platform;

import mezz.jei.common.platform.IPlatformRegistry;
import net.fabricmc.fabric.mixin.registry.sync.RegistryAccessor;
import net.minecraft.class_2378;
import net.minecraft.class_2385;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import net.minecraft.class_6880;
import org.jetbrains.annotations.Nullable;

import java.util.Optional;
import java.util.stream.Stream;

public class RegistryWrapper<T> implements IPlatformRegistry<T> {
    public static <T> IPlatformRegistry<T> getRegistry(class_5321<? extends class_2378<T>> key) {
        class_2385<class_2385<?>> rootRegistry = RegistryAccessor.getROOT();
        class_2385<?> registry = rootRegistry.method_10223(key.method_29177());
        IPlatformRegistry<?> registryWrapper = new RegistryWrapper<>(registry);
        @SuppressWarnings("unchecked")
        IPlatformRegistry<T> castPlatformRegistry = (IPlatformRegistry<T>) registryWrapper;
        return castPlatformRegistry;
    }

    private final class_2385<T> registry;

    private RegistryWrapper(class_2385<T> registry) {
        this.registry = registry;
    }

    @Override
    public Stream<T> getValues() {
        return this.registry.method_10220();
    }

    @Nullable
    @Override
    public T getValue(class_2960 resourceLocation) {
        return this.registry.method_10223(resourceLocation);
    }

    @Override
    public int getId(T entry) {
        return this.registry.method_10206(entry);
    }

    @Override
    public Optional<T> getValue(int id) {
        return this.registry.method_40265(id).map(class_6880::comp_349);
    }

    @Override
    public boolean contains(T entry) {
        return this.registry.method_10221(entry) != null;
    }

    @Override
    @Nullable
    public class_2960 getRegistryName(T entry) {
        return this.registry.method_10221(entry);
    }
}
